/*
 * intra.h
 *
 * Description of this file:
 *    Intra prediction functions definition of the xRD library
 *
 * --------------------------------------------------------------------------
 *
 *    xRD - video encoder of AVS2/IEEE1857.4 video coding standard
 *    Copyright (C) 2018~ VCL, NELVT, Peking University
 *
 *    Authors: Falei LUO <falei.luo@gmail.com>
 *             etc.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111, USA.
 *
 *    This program is also available under a commercial proprietary license.
 *    For more information, contact us at sswang @ pku.edu.cn.
 */

#ifndef __XRD_INTRA_H__
#define __XRD_INTRA_H__

typedef struct intra_candidate_t intra_candidate_t;

uint32_t xrd_intra_get_cu_neighbors(xrd_t *h, cu_t *p_cu, int img_x, int img_y, int cu_size);

void xrd_intra_fill_ref_samples_luma(xrd_t *h, cu_t *p_cu, int img_x, int img_y, 
                                       int block_x, int block_y, int bsx, int bsy);

int rdo_get_pred_intra_luma(xrd_t *h, cu_t *p_cu, intra_candidate_t *p_candidates,
                            pel_t *p_fenc, int mpm[], int blockidx,
                            int block_x, int block_y, int block_w, int block_h);

int rdo_get_pred_intra_luma_cuda(xrd_t *h, cu_t *p_cu, intra_candidate_t *p_candidates,
                                 pel_t *p_fenc, int mpm[], int blockidx,
                                 int block_x, int block_y, int block_w, int block_h);

int rdo_get_pred_intra_chroma(xrd_t *h, cu_t *p_cu, int i_level, int pix_y_c, int pix_x_c,
                              intra_candidate_t *p_candidate_list);


#endif  // __XRD_INTRA_H__
