/*
 * threadpool.h
 *
 * Description of this file:
 *    thread pooling functions definition of the xRD library
 *
 * --------------------------------------------------------------------------
 *
 *    xRD - video encoder of AVS2/IEEE1857.4 video coding standard
 *    Copyright (C) 2018~ VCL, NELVT, Peking University
 *
 *    Authors: Falei LUO <falei.luo@gmail.com>
 *             etc.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111, USA.
 *
 *    This program is also available under a commercial proprietary license.
 *    For more information, contact us at sswang @ pku.edu.cn.
 */

#ifndef __XRD_THREADPOOL_H__
#define __XRD_THREADPOOL_H__

typedef struct xrd_threadpool_t xrd_threadpool_t;

int   xrd_threadpool_init  (xrd_threadpool_t **p_pool, int threads,
                              xrd_tfunc_t init_func, void *init_arg);
void  xrd_threadpool_run   (xrd_threadpool_t *pool, void *(*func)(void *), void *arg, int wait_sign);
void *xrd_threadpool_wait  (xrd_threadpool_t *pool, void *arg);
void  xrd_threadpool_delete(xrd_threadpool_t *pool);

#endif  // __XRD_THREADPOOL_H__
