/*
 * tdrdo.h
 *
 * Description of this file:
 *    TDRDO functions definition of the xRD library
 *
 * --------------------------------------------------------------------------
 *
 *    xRD - video encoder of AVS2/IEEE1857.4 video coding standard
 *    Copyright (C) 2018~ VCL, NELVT, Peking University
 *
 *    Authors: Falei LUO <falei.luo@gmail.com>
 *             etc.
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02111, USA.
 *
 *    This program is also available under a commercial proprietary license.
 *    For more information, contact us at sswang @ pku.edu.cn.
 */

#ifndef __XRD_TDRDO_H__
#define __XRD_TDRDO_H__


/**
 * ===========================================================================
 * function declares
 * ===========================================================================
 */
int  tdrdo_get_buffer_size(xrd_param_t *param);
int  tdrdo_init(td_rdo_t *td_rdo, xrd_param_t *param);
void tdrdo_destroy(td_rdo_t *td_rdo);

void tdrdo_frame_start(xrd_t *h);
void tdrdo_frame_done(xrd_t *h);
void tdrdo_lcu_adjust_lambda(xrd_t *h, rdcost_t *new_lambda);
void tdrdo_lcu_update(xrd_t *h);

#endif  // __XRD_TDRDO_H__
